/* PolkitDialog.c generated by valac 0.56.18, the Vala compiler
 * generated from PolkitDialog.vala, do not modify */

/*-
 * Copyright (c) 2015-2019 elementary, Inc. (https://elementary.io)
 * Copyright (C) 2015-2016 Ikey Doherty <ikey@solus-project.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */
/*
 * Code based on budgie-desktop:
 * https://github.com/solus-project/budgie-desktop
 */

#include <granite.h>
#include <glib-object.h>
#include <glib.h>
#include <polkitagent/polkitagent.h>
#include <polkit/polkit.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <pwd.h>
#include <sys/types.h>
#include <grp.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define AG_WIDGETS_TYPE_POLKIT_DIALOG (ag_widgets_polkit_dialog_get_type ())
#define AG_WIDGETS_POLKIT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialog))
#define AG_WIDGETS_POLKIT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialogClass))
#define AG_WIDGETS_IS_POLKIT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AG_WIDGETS_TYPE_POLKIT_DIALOG))
#define AG_WIDGETS_IS_POLKIT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AG_WIDGETS_TYPE_POLKIT_DIALOG))
#define AG_WIDGETS_POLKIT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialogClass))

typedef struct _AgWidgetsPolkitDialog AgWidgetsPolkitDialog;
typedef struct _AgWidgetsPolkitDialogClass AgWidgetsPolkitDialogClass;
typedef struct _AgWidgetsPolkitDialogPrivate AgWidgetsPolkitDialogPrivate;
enum  {
	AG_WIDGETS_POLKIT_DIALOG_0_PROPERTY,
	AG_WIDGETS_POLKIT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* ag_widgets_polkit_dialog_properties[AG_WIDGETS_POLKIT_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block3Data Block3Data;
enum  {
	AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL,
	AG_WIDGETS_POLKIT_DIALOG_NUM_SIGNALS
};
static guint ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_NUM_SIGNALS] = {0};

struct _AgWidgetsPolkitDialog {
	GraniteMessageDialog parent_instance;
	AgWidgetsPolkitDialogPrivate * priv;
	gboolean was_canceled;
};

struct _AgWidgetsPolkitDialogClass {
	GraniteMessageDialogClass parent_class;
};

struct _AgWidgetsPolkitDialogPrivate {
	PolkitAgentSession* pk_session;
	PolkitIdentity* pk_identity;
	GCancellable* cancellable;
	gulong error_signal_id;
	gulong request_signal_id;
	gulong info_signal_id;
	gulong complete_signal_id;
	GList* idents;
	gchar* cookie;
	gboolean canceling;
	GtkRevealer* feedback_revealer;
	GtkLabel* password_label;
	GtkLabel* password_feedback;
	GtkEntry* password_entry;
	GtkComboBox* idents_combo;
};

struct _Block3Data {
	int _ref_count_;
	AgWidgetsPolkitDialog* self;
	GraniteSettings* granite_settings;
	GtkSettings* gtk_settings;
};

static gint AgWidgetsPolkitDialog_private_offset;
static gpointer ag_widgets_polkit_dialog_parent_class = NULL;

VALA_EXTERN GType ag_widgets_polkit_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AgWidgetsPolkitDialog, g_object_unref)
VALA_EXTERN AgWidgetsPolkitDialog* ag_widgets_polkit_dialog_new (const gchar* message,
                                                     const gchar* icon_name,
                                                     const gchar* _cookie,
                                                     GList* _idents,
                                                     GCancellable* _cancellable);
VALA_EXTERN AgWidgetsPolkitDialog* ag_widgets_polkit_dialog_construct (GType object_type,
                                                           const gchar* message,
                                                           const gchar* icon_name,
                                                           const gchar* _cookie,
                                                           GList* _idents,
                                                           GCancellable* _cancellable);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void ag_widgets_polkit_dialog_cancel (AgWidgetsPolkitDialog* self);
static void _ag_widgets_polkit_dialog_cancel_g_cancellable_cancelled (GCancellable* _sender,
                                                               gpointer self);
static void ag_widgets_polkit_dialog_on_ident_changed (AgWidgetsPolkitDialog* self);
static void _ag_widgets_polkit_dialog_on_ident_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                       gpointer self);
static void __lambda7_ (AgWidgetsPolkitDialog* self);
static void ___lambda7__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void ag_widgets_polkit_dialog_authenticate (AgWidgetsPolkitDialog* self);
static void _ag_widgets_polkit_dialog_authenticate_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static gboolean ag_widgets_polkit_dialog_on_key_release (AgWidgetsPolkitDialog* self,
                                                  GdkEventKey* key);
static gboolean _ag_widgets_polkit_dialog_on_key_release_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                                GdkEventKey* event,
                                                                                gpointer self);
static void _ag_widgets_polkit_dialog_cancel_gtk_dialog_close (GtkDialog* _sender,
                                                        gpointer self);
static void ag_widgets_polkit_dialog_update_idents (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_select_session (AgWidgetsPolkitDialog* self);
static void __lambda8_ (Block3Data* _data3_);
static void ___lambda8__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void ag_widgets_polkit_dialog_real_show (GtkWidget* base);
static void ag_widgets_polkit_dialog_deselect_session (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_on_pk_show_error (AgWidgetsPolkitDialog* self,
                                                const gchar* text);
static void _ag_widgets_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error (PolkitAgentSession* _sender,
                                                                                 const gchar* text,
                                                                                 gpointer self);
static void ag_widgets_polkit_dialog_on_pk_session_completed (AgWidgetsPolkitDialog* self,
                                                       gboolean authorized);
static void _ag_widgets_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed (PolkitAgentSession* _sender,
                                                                                       gboolean gained_authorization,
                                                                                       gpointer self);
static void ag_widgets_polkit_dialog_on_pk_request (AgWidgetsPolkitDialog* self,
                                             const gchar* request,
                                             gboolean echo_on);
static void _ag_widgets_polkit_dialog_on_pk_request_polkit_agent_session_request (PolkitAgentSession* _sender,
                                                                           const gchar* request,
                                                                           gboolean echo_on,
                                                                           gpointer self);
static void ag_widgets_polkit_dialog_on_pk_show_info (AgWidgetsPolkitDialog* self,
                                               const gchar* text);
static void _ag_widgets_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info (PolkitAgentSession* _sender,
                                                                               const gchar* text,
                                                                               gpointer self);
static void ag_widgets_polkit_dialog_shake (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_finalize (GObject * obj);
static GType ag_widgets_polkit_dialog_get_type_once (void);

static inline gpointer
ag_widgets_polkit_dialog_get_instance_private (AgWidgetsPolkitDialog* self)
{
	return G_STRUCT_MEMBER_P (self, AgWidgetsPolkitDialog_private_offset);
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 50 "../src/PolkitDialog.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 50 "../src/PolkitDialog.vala"
	return _data3_;
#line 207 "PolkitDialog.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 50 "../src/PolkitDialog.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 217 "PolkitDialog.c"
		AgWidgetsPolkitDialog* self;
#line 50 "../src/PolkitDialog.vala"
		self = _data3_->self;
#line 50 "../src/PolkitDialog.vala"
		_g_object_unref0 (_data3_->gtk_settings);
#line 50 "../src/PolkitDialog.vala"
		_g_object_unref0 (_data3_->granite_settings);
#line 50 "../src/PolkitDialog.vala"
		_g_object_unref0 (self);
#line 50 "../src/PolkitDialog.vala"
		g_slice_free (Block3Data, _data3_);
#line 229 "PolkitDialog.c"
	}
}

static void
_ag_widgets_polkit_dialog_cancel_g_cancellable_cancelled (GCancellable* _sender,
                                                          gpointer self)
{
#line 59 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_cancel ((AgWidgetsPolkitDialog*) self);
#line 239 "PolkitDialog.c"
}

static void
_ag_widgets_polkit_dialog_on_ident_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                  gpointer self)
{
#line 84 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_on_ident_changed ((AgWidgetsPolkitDialog*) self);
#line 248 "PolkitDialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 111 "../src/PolkitDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 256 "PolkitDialog.c"
}

static void
__lambda7_ (AgWidgetsPolkitDialog* self)
{
#line 112 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_cancel (self);
#line 264 "PolkitDialog.c"
}

static void
___lambda7__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 112 "../src/PolkitDialog.vala"
	__lambda7_ ((AgWidgetsPolkitDialog*) self);
#line 273 "PolkitDialog.c"
}

static void
_ag_widgets_polkit_dialog_authenticate_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
#line 116 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_authenticate ((AgWidgetsPolkitDialog*) self);
#line 282 "PolkitDialog.c"
}

static gboolean
_ag_widgets_polkit_dialog_on_key_release_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                       GdkEventKey* event,
                                                                       gpointer self)
{
	gboolean result;
	result = ag_widgets_polkit_dialog_on_key_release ((AgWidgetsPolkitDialog*) self, event);
#line 120 "../src/PolkitDialog.vala"
	return result;
#line 294 "PolkitDialog.c"
}

static void
_ag_widgets_polkit_dialog_cancel_gtk_dialog_close (GtkDialog* _sender,
                                                   gpointer self)
{
#line 121 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_cancel ((AgWidgetsPolkitDialog*) self);
#line 303 "PolkitDialog.c"
}

static void
__lambda8_ (Block3Data* _data3_)
{
	AgWidgetsPolkitDialog* self;
	GraniteSettingsColorScheme _tmp0_;
	GraniteSettingsColorScheme _tmp1_;
#line 131 "../src/PolkitDialog.vala"
	self = _data3_->self;
#line 132 "../src/PolkitDialog.vala"
	_tmp0_ = granite_settings_get_prefers_color_scheme (_data3_->granite_settings);
#line 132 "../src/PolkitDialog.vala"
	_tmp1_ = _tmp0_;
#line 132 "../src/PolkitDialog.vala"
	g_object_set (_data3_->gtk_settings, "gtk-application-prefer-dark-theme", _tmp1_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK, NULL);
#line 320 "PolkitDialog.c"
}

static void
___lambda8__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 131 "../src/PolkitDialog.vala"
	__lambda8_ (self);
#line 330 "PolkitDialog.c"
}

AgWidgetsPolkitDialog*
ag_widgets_polkit_dialog_construct (GType object_type,
                                    const gchar* message,
                                    const gchar* icon_name,
                                    const gchar* _cookie,
                                    GList* _idents,
                                    GCancellable* _cancellable)
{
	AgWidgetsPolkitDialog * self = NULL;
	Block3Data* _data3_;
	gchar* _tmp0_;
	GCancellable* _tmp1_;
	GtkEntry* _tmp2_;
	GtkEntry* _tmp3_;
	GtkEntry* _tmp4_;
	GtkEntry* _tmp5_;
	GtkEntry* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkRevealer* _tmp14_;
	GtkRevealer* _tmp15_;
	GtkLabel* _tmp16_;
	GtkComboBox* _tmp17_;
	GtkComboBox* _tmp18_;
	GtkComboBox* _tmp19_;
	GtkCellRenderer* renderer = NULL;
	GtkCellRendererPixbuf* _tmp20_;
	GtkComboBox* _tmp21_;
	GtkCellRenderer* _tmp22_;
	GtkComboBox* _tmp23_;
	GtkCellRenderer* _tmp24_;
	GtkCellRendererText* _tmp25_;
	GtkCellRenderer* _tmp26_;
	GtkComboBox* _tmp27_;
	GtkCellRenderer* _tmp28_;
	GtkComboBox* _tmp29_;
	GtkCellRenderer* _tmp30_;
	GtkComboBox* _tmp31_;
	GtkGrid* credentials_grid = NULL;
	GtkGrid* _tmp32_;
	GtkGrid* _tmp33_;
	GtkGrid* _tmp34_;
	GtkGrid* _tmp35_;
	GtkComboBox* _tmp36_;
	GtkGrid* _tmp37_;
	GtkEntry* _tmp38_;
	GtkGrid* _tmp39_;
	GtkRevealer* _tmp40_;
	GThemedIcon* _tmp41_;
	GThemedIcon* _tmp42_;
	gboolean _tmp43_ = FALSE;
	GtkBin* _tmp47_;
	GtkBin* _tmp48_;
	GtkGrid* _tmp49_;
	GtkButton* cancel_button = NULL;
	GtkWidget* _tmp50_;
	GtkButton* _tmp51_;
	GtkButton* authenticate_button = NULL;
	GtkWidget* _tmp52_;
	GtkButton* _tmp53_;
	GtkStyleContext* _tmp54_;
	GraniteSettings* _tmp55_;
	GraniteSettings* _tmp56_;
	GtkSettings* _tmp57_;
	GtkSettings* _tmp58_;
	GraniteSettingsColorScheme _tmp59_;
	GraniteSettingsColorScheme _tmp60_;
#line 50 "../src/PolkitDialog.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 50 "../src/PolkitDialog.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 50 "../src/PolkitDialog.vala"
	g_return_val_if_fail (_cookie != NULL, NULL);
#line 50 "../src/PolkitDialog.vala"
	g_return_val_if_fail (_cancellable != NULL, NULL);
#line 50 "../src/PolkitDialog.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 50 "../src/PolkitDialog.vala"
	_data3_->_ref_count_ = 1;
#line 52 "../src/PolkitDialog.vala"
	self = (AgWidgetsPolkitDialog*) g_object_new (object_type, "title", _ ("Authentication Dialog"), NULL);
#line 52 "../src/PolkitDialog.vala"
	_data3_->self = g_object_ref (self);
#line 56 "../src/PolkitDialog.vala"
	self->priv->idents = _idents;
#line 57 "../src/PolkitDialog.vala"
	_tmp0_ = g_strdup (_cookie);
#line 57 "../src/PolkitDialog.vala"
	_g_free0 (self->priv->cookie);
#line 57 "../src/PolkitDialog.vala"
	self->priv->cookie = _tmp0_;
#line 58 "../src/PolkitDialog.vala"
	self->priv->cancellable = _cancellable;
#line 59 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->cancellable;
#line 59 "../src/PolkitDialog.vala"
	g_signal_connect_object (_tmp1_, "cancelled", (GCallback) _ag_widgets_polkit_dialog_cancel_g_cancellable_cancelled, self, 0);
#line 61 "../src/PolkitDialog.vala"
	granite_message_dialog_set_primary_text ((GraniteMessageDialog*) self, _ ("Authentication Required"));
#line 62 "../src/PolkitDialog.vala"
	granite_message_dialog_set_secondary_text ((GraniteMessageDialog*) self, message);
#line 63 "../src/PolkitDialog.vala"
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) self, TRUE);
#line 64 "../src/PolkitDialog.vala"
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
#line 66 "../src/PolkitDialog.vala"
	_tmp2_ = (GtkEntry*) gtk_entry_new ();
#line 66 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp2_);
#line 66 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_entry);
#line 66 "../src/PolkitDialog.vala"
	self->priv->password_entry = _tmp2_;
#line 67 "../src/PolkitDialog.vala"
	_tmp3_ = self->priv->password_entry;
#line 67 "../src/PolkitDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp3_, TRUE);
#line 68 "../src/PolkitDialog.vala"
	_tmp4_ = self->priv->password_entry;
#line 68 "../src/PolkitDialog.vala"
	gtk_entry_set_input_purpose (_tmp4_, GTK_INPUT_PURPOSE_PASSWORD);
#line 69 "../src/PolkitDialog.vala"
	_tmp5_ = self->priv->password_entry;
#line 69 "../src/PolkitDialog.vala"
	g_object_set (_tmp5_, "primary-icon-name", "dialog-password-symbolic", NULL);
#line 70 "../src/PolkitDialog.vala"
	_tmp6_ = self->priv->password_entry;
#line 70 "../src/PolkitDialog.vala"
	g_object_set (_tmp6_, "primary-icon-tooltip-text", _ ("Password"), NULL);
#line 72 "../src/PolkitDialog.vala"
	_tmp7_ = (GtkLabel*) gtk_label_new (NULL);
#line 72 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp7_);
#line 72 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_feedback);
#line 72 "../src/PolkitDialog.vala"
	self->priv->password_feedback = _tmp7_;
#line 73 "../src/PolkitDialog.vala"
	_tmp8_ = self->priv->password_feedback;
#line 73 "../src/PolkitDialog.vala"
	gtk_label_set_justify (_tmp8_, GTK_JUSTIFY_RIGHT);
#line 74 "../src/PolkitDialog.vala"
	_tmp9_ = self->priv->password_feedback;
#line 74 "../src/PolkitDialog.vala"
	gtk_label_set_max_width_chars (_tmp9_, 40);
#line 75 "../src/PolkitDialog.vala"
	_tmp10_ = self->priv->password_feedback;
#line 75 "../src/PolkitDialog.vala"
	g_object_set (_tmp10_, "wrap", TRUE, NULL);
#line 76 "../src/PolkitDialog.vala"
	_tmp11_ = self->priv->password_feedback;
#line 76 "../src/PolkitDialog.vala"
	gtk_label_set_xalign (_tmp11_, (gfloat) 1);
#line 77 "../src/PolkitDialog.vala"
	_tmp12_ = self->priv->password_feedback;
#line 77 "../src/PolkitDialog.vala"
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) _tmp12_);
#line 77 "../src/PolkitDialog.vala"
	gtk_style_context_add_class (_tmp13_, GTK_STYLE_CLASS_ERROR);
#line 79 "../src/PolkitDialog.vala"
	_tmp14_ = (GtkRevealer*) gtk_revealer_new ();
#line 79 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp14_);
#line 79 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->feedback_revealer);
#line 79 "../src/PolkitDialog.vala"
	self->priv->feedback_revealer = _tmp14_;
#line 80 "../src/PolkitDialog.vala"
	_tmp15_ = self->priv->feedback_revealer;
#line 80 "../src/PolkitDialog.vala"
	_tmp16_ = self->priv->password_feedback;
#line 80 "../src/PolkitDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
#line 82 "../src/PolkitDialog.vala"
	_tmp17_ = (GtkComboBox*) gtk_combo_box_new ();
#line 82 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp17_);
#line 82 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->idents_combo);
#line 82 "../src/PolkitDialog.vala"
	self->priv->idents_combo = _tmp17_;
#line 83 "../src/PolkitDialog.vala"
	_tmp18_ = self->priv->idents_combo;
#line 83 "../src/PolkitDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp18_, TRUE);
#line 84 "../src/PolkitDialog.vala"
	_tmp19_ = self->priv->idents_combo;
#line 84 "../src/PolkitDialog.vala"
	g_signal_connect_object (_tmp19_, "changed", (GCallback) _ag_widgets_polkit_dialog_on_ident_changed_gtk_combo_box_changed, self, 0);
#line 86 "../src/PolkitDialog.vala"
	_tmp20_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
#line 86 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp20_);
#line 86 "../src/PolkitDialog.vala"
	renderer = (GtkCellRenderer*) _tmp20_;
#line 87 "../src/PolkitDialog.vala"
	_tmp21_ = self->priv->idents_combo;
#line 87 "../src/PolkitDialog.vala"
	_tmp22_ = renderer;
#line 87 "../src/PolkitDialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp21_, _tmp22_, FALSE);
#line 88 "../src/PolkitDialog.vala"
	_tmp23_ = self->priv->idents_combo;
#line 88 "../src/PolkitDialog.vala"
	_tmp24_ = renderer;
#line 88 "../src/PolkitDialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp23_, _tmp24_, "icon-name", 0);
#line 90 "../src/PolkitDialog.vala"
	_tmp25_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 90 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp25_);
#line 90 "../src/PolkitDialog.vala"
	_g_object_unref0 (renderer);
#line 90 "../src/PolkitDialog.vala"
	renderer = (GtkCellRenderer*) _tmp25_;
#line 91 "../src/PolkitDialog.vala"
	_tmp26_ = renderer;
#line 91 "../src/PolkitDialog.vala"
	g_object_set (_tmp26_, "xpad", (guint) 6, NULL);
#line 92 "../src/PolkitDialog.vala"
	_tmp27_ = self->priv->idents_combo;
#line 92 "../src/PolkitDialog.vala"
	_tmp28_ = renderer;
#line 92 "../src/PolkitDialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp27_, _tmp28_, TRUE);
#line 93 "../src/PolkitDialog.vala"
	_tmp29_ = self->priv->idents_combo;
#line 93 "../src/PolkitDialog.vala"
	_tmp30_ = renderer;
#line 93 "../src/PolkitDialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp29_, _tmp30_, "text", 1);
#line 94 "../src/PolkitDialog.vala"
	_tmp31_ = self->priv->idents_combo;
#line 94 "../src/PolkitDialog.vala"
	gtk_combo_box_set_id_column (_tmp31_, 1);
#line 96 "../src/PolkitDialog.vala"
	_tmp32_ = (GtkGrid*) gtk_grid_new ();
#line 96 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp32_);
#line 96 "../src/PolkitDialog.vala"
	credentials_grid = _tmp32_;
#line 97 "../src/PolkitDialog.vala"
	_tmp33_ = credentials_grid;
#line 97 "../src/PolkitDialog.vala"
	gtk_grid_set_column_spacing (_tmp33_, 12);
#line 98 "../src/PolkitDialog.vala"
	_tmp34_ = credentials_grid;
#line 98 "../src/PolkitDialog.vala"
	gtk_grid_set_row_spacing (_tmp34_, 6);
#line 99 "../src/PolkitDialog.vala"
	_tmp35_ = credentials_grid;
#line 99 "../src/PolkitDialog.vala"
	_tmp36_ = self->priv->idents_combo;
#line 99 "../src/PolkitDialog.vala"
	gtk_grid_attach (_tmp35_, (GtkWidget*) _tmp36_, 0, 0, 1, 1);
#line 100 "../src/PolkitDialog.vala"
	_tmp37_ = credentials_grid;
#line 100 "../src/PolkitDialog.vala"
	_tmp38_ = self->priv->password_entry;
#line 100 "../src/PolkitDialog.vala"
	gtk_grid_attach (_tmp37_, (GtkWidget*) _tmp38_, 0, 2, 1, 1);
#line 101 "../src/PolkitDialog.vala"
	_tmp39_ = credentials_grid;
#line 101 "../src/PolkitDialog.vala"
	_tmp40_ = self->priv->feedback_revealer;
#line 101 "../src/PolkitDialog.vala"
	gtk_grid_attach (_tmp39_, (GtkWidget*) _tmp40_, 0, 3, 1, 1);
#line 103 "../src/PolkitDialog.vala"
	_tmp41_ = (GThemedIcon*) g_themed_icon_new ("dialog-password");
#line 103 "../src/PolkitDialog.vala"
	_tmp42_ = _tmp41_;
#line 103 "../src/PolkitDialog.vala"
	granite_message_dialog_set_image_icon ((GraniteMessageDialog*) self, (GIcon*) _tmp42_);
#line 103 "../src/PolkitDialog.vala"
	_g_object_unref0 (_tmp42_);
#line 105 "../src/PolkitDialog.vala"
	if (g_strcmp0 (icon_name, "") != 0) {
#line 615 "PolkitDialog.c"
		GtkIconTheme* _tmp44_;
#line 105 "../src/PolkitDialog.vala"
		_tmp44_ = gtk_icon_theme_get_default ();
#line 105 "../src/PolkitDialog.vala"
		_tmp43_ = gtk_icon_theme_has_icon (_tmp44_, icon_name);
#line 621 "PolkitDialog.c"
	} else {
#line 105 "../src/PolkitDialog.vala"
		_tmp43_ = FALSE;
#line 625 "PolkitDialog.c"
	}
#line 105 "../src/PolkitDialog.vala"
	if (_tmp43_) {
#line 629 "PolkitDialog.c"
		GThemedIcon* _tmp45_;
		GThemedIcon* _tmp46_;
#line 106 "../src/PolkitDialog.vala"
		_tmp45_ = (GThemedIcon*) g_themed_icon_new (icon_name);
#line 106 "../src/PolkitDialog.vala"
		_tmp46_ = _tmp45_;
#line 106 "../src/PolkitDialog.vala"
		granite_message_dialog_set_badge_icon ((GraniteMessageDialog*) self, (GIcon*) _tmp46_);
#line 106 "../src/PolkitDialog.vala"
		_g_object_unref0 (_tmp46_);
#line 640 "PolkitDialog.c"
	}
#line 109 "../src/PolkitDialog.vala"
	_tmp47_ = granite_message_dialog_get_custom_bin ((GraniteMessageDialog*) self);
#line 109 "../src/PolkitDialog.vala"
	_tmp48_ = _tmp47_;
#line 109 "../src/PolkitDialog.vala"
	_tmp49_ = credentials_grid;
#line 109 "../src/PolkitDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp48_, (GtkWidget*) _tmp49_);
#line 111 "../src/PolkitDialog.vala"
	_tmp50_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 111 "../src/PolkitDialog.vala"
	_tmp51_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, gtk_button_get_type (), GtkButton));
#line 111 "../src/PolkitDialog.vala"
	cancel_button = _tmp51_;
#line 112 "../src/PolkitDialog.vala"
	g_signal_connect_object (cancel_button, "clicked", (GCallback) ___lambda7__gtk_button_clicked, self, 0);
#line 114 "../src/PolkitDialog.vala"
	_tmp52_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Authenticate"), (gint) GTK_RESPONSE_APPLY);
#line 114 "../src/PolkitDialog.vala"
	_tmp53_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, gtk_button_get_type (), GtkButton));
#line 114 "../src/PolkitDialog.vala"
	authenticate_button = _tmp53_;
#line 115 "../src/PolkitDialog.vala"
	_tmp54_ = gtk_widget_get_style_context ((GtkWidget*) authenticate_button);
#line 115 "../src/PolkitDialog.vala"
	gtk_style_context_add_class (_tmp54_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 116 "../src/PolkitDialog.vala"
	g_signal_connect_object (authenticate_button, "clicked", (GCallback) _ag_widgets_polkit_dialog_authenticate_gtk_button_clicked, self, 0);
#line 118 "../src/PolkitDialog.vala"
	gtk_window_set_default ((GtkWindow*) self, (GtkWidget*) authenticate_button);
#line 120 "../src/PolkitDialog.vala"
	g_signal_connect_object ((GtkWidget*) self, "key-release-event", (GCallback) _ag_widgets_polkit_dialog_on_key_release_gtk_widget_key_release_event, self, 0);
#line 121 "../src/PolkitDialog.vala"
	g_signal_connect_object ((GtkDialog*) self, "close", (GCallback) _ag_widgets_polkit_dialog_cancel_gtk_dialog_close, self, 0);
#line 123 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_update_idents (self);
#line 124 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_select_session (self);
#line 126 "../src/PolkitDialog.vala"
	_tmp55_ = granite_settings_get_default ();
#line 126 "../src/PolkitDialog.vala"
	_tmp56_ = _g_object_ref0 (_tmp55_);
#line 126 "../src/PolkitDialog.vala"
	_data3_->granite_settings = _tmp56_;
#line 127 "../src/PolkitDialog.vala"
	_tmp57_ = gtk_settings_get_default ();
#line 127 "../src/PolkitDialog.vala"
	_tmp58_ = _g_object_ref0 (_tmp57_);
#line 127 "../src/PolkitDialog.vala"
	_data3_->gtk_settings = _tmp58_;
#line 129 "../src/PolkitDialog.vala"
	_tmp59_ = granite_settings_get_prefers_color_scheme (_data3_->granite_settings);
#line 129 "../src/PolkitDialog.vala"
	_tmp60_ = _tmp59_;
#line 129 "../src/PolkitDialog.vala"
	g_object_set (_data3_->gtk_settings, "gtk-application-prefer-dark-theme", _tmp60_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK, NULL);
#line 131 "../src/PolkitDialog.vala"
	g_signal_connect_data ((GObject*) _data3_->granite_settings, "notify::prefers-color-scheme", (GCallback) ___lambda8__g_object_notify, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (authenticate_button);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (cancel_button);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (credentials_grid);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (renderer);
#line 50 "../src/PolkitDialog.vala"
	block3_data_unref (_data3_);
#line 50 "../src/PolkitDialog.vala"
	_data3_ = NULL;
#line 50 "../src/PolkitDialog.vala"
	return self;
#line 714 "PolkitDialog.c"
}

AgWidgetsPolkitDialog*
ag_widgets_polkit_dialog_new (const gchar* message,
                              const gchar* icon_name,
                              const gchar* _cookie,
                              GList* _idents,
                              GCancellable* _cancellable)
{
#line 50 "../src/PolkitDialog.vala"
	return ag_widgets_polkit_dialog_construct (AG_WIDGETS_TYPE_POLKIT_DIALOG, message, icon_name, _cookie, _idents, _cancellable);
#line 726 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_real_show (GtkWidget* base)
{
	AgWidgetsPolkitDialog * self;
	GdkWindow* window = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	GdkWindow* _tmp3_;
	GtkEntry* _tmp4_;
#line 136 "../src/PolkitDialog.vala"
	self = (AgWidgetsPolkitDialog*) base;
#line 137 "../src/PolkitDialog.vala"
	GTK_WIDGET_CLASS (ag_widgets_polkit_dialog_parent_class)->show ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, GRANITE_TYPE_MESSAGE_DIALOG, GraniteMessageDialog));
#line 139 "../src/PolkitDialog.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 139 "../src/PolkitDialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 139 "../src/PolkitDialog.vala"
	window = _tmp1_;
#line 140 "../src/PolkitDialog.vala"
	_tmp2_ = window;
#line 140 "../src/PolkitDialog.vala"
	if (_tmp2_ == NULL) {
#line 141 "../src/PolkitDialog.vala"
		_g_object_unref0 (window);
#line 141 "../src/PolkitDialog.vala"
		return;
#line 757 "PolkitDialog.c"
	}
#line 144 "../src/PolkitDialog.vala"
	_tmp3_ = window;
#line 144 "../src/PolkitDialog.vala"
	gdk_window_focus (_tmp3_, (guint32) GDK_CURRENT_TIME);
#line 145 "../src/PolkitDialog.vala"
	_tmp4_ = self->priv->password_entry;
#line 145 "../src/PolkitDialog.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp4_);
#line 136 "../src/PolkitDialog.vala"
	_g_object_unref0 (window);
#line 769 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_update_idents (AgWidgetsPolkitDialog* self)
{
	GtkListStore* model = NULL;
	GtkListStore* _tmp0_;
	GtkTreeIter iter = {0};
	gint length = 0;
	gint active = 0;
	gchar* target_user = NULL;
	GList* _tmp1_;
	GtkComboBox* _tmp34_;
	GtkListStore* _tmp35_;
	GtkComboBox* _tmp36_;
#line 148 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 149 "../src/PolkitDialog.vala"
	_tmp0_ = gtk_list_store_new (3, G_TYPE_STRING, G_TYPE_STRING, polkit_identity_get_type (), -1);
#line 149 "../src/PolkitDialog.vala"
	model = _tmp0_;
#line 152 "../src/PolkitDialog.vala"
	length = 0;
#line 153 "../src/PolkitDialog.vala"
	active = 0;
#line 155 "../src/PolkitDialog.vala"
	target_user = NULL;
#line 157 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->idents;
#line 799 "PolkitDialog.c"
	{
		GList* ident_collection = NULL;
		GList* ident_it = NULL;
#line 157 "../src/PolkitDialog.vala"
		ident_collection = _tmp1_;
#line 157 "../src/PolkitDialog.vala"
		for (ident_it = ident_collection; ident_it != NULL; ident_it = ident_it->next) {
#line 807 "PolkitDialog.c"
			PolkitIdentity* ident = NULL;
#line 157 "../src/PolkitDialog.vala"
			ident = (PolkitIdentity*) ident_it->data;
#line 811 "PolkitDialog.c"
			{
				PolkitIdentity* _tmp2_;
				gchar* name = NULL;
				PolkitIdentity* _tmp3_;
				gchar* _tmp4_;
				PolkitIdentity* _tmp5_;
				GtkListStore* _tmp25_;
				GtkTreeIter _tmp26_ = {0};
				GtkListStore* _tmp27_;
				GtkTreeIter _tmp28_;
				const gchar* _tmp29_;
				PolkitIdentity* _tmp30_;
				const gchar* _tmp31_;
				const gchar* _tmp32_;
				gint _tmp33_;
#line 158 "../src/PolkitDialog.vala"
				_tmp2_ = ident;
#line 158 "../src/PolkitDialog.vala"
				if (_tmp2_ == NULL) {
#line 159 "../src/PolkitDialog.vala"
					continue;
#line 833 "PolkitDialog.c"
				}
#line 162 "../src/PolkitDialog.vala"
				_tmp3_ = ident;
#line 162 "../src/PolkitDialog.vala"
				_tmp4_ = polkit_identity_to_string (_tmp3_);
#line 162 "../src/PolkitDialog.vala"
				name = _tmp4_;
#line 164 "../src/PolkitDialog.vala"
				_tmp5_ = ident;
#line 164 "../src/PolkitDialog.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, polkit_unix_user_get_type ())) {
#line 845 "PolkitDialog.c"
					struct passwd* pwd = NULL;
					PolkitIdentity* _tmp6_;
					struct passwd* _tmp7_;
					struct passwd* _tmp8_;
#line 165 "../src/PolkitDialog.vala"
					_tmp6_ = ident;
#line 165 "../src/PolkitDialog.vala"
					_tmp7_ = getpwuid ((uid_t) polkit_unix_user_get_uid (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, polkit_unix_user_get_type (), PolkitUnixUser)));
#line 165 "../src/PolkitDialog.vala"
					pwd = _tmp7_;
#line 166 "../src/PolkitDialog.vala"
					_tmp8_ = pwd;
#line 166 "../src/PolkitDialog.vala"
					if (_tmp8_ != NULL) {
#line 860 "PolkitDialog.c"
						gchar* pw_name = NULL;
						struct passwd* _tmp9_;
						const gchar* _tmp10_;
						gchar* _tmp11_;
						gboolean _tmp12_ = FALSE;
						const gchar* _tmp13_;
						const gchar* _tmp16_;
						gchar* _tmp17_;
#line 167 "../src/PolkitDialog.vala"
						_tmp9_ = pwd;
#line 167 "../src/PolkitDialog.vala"
						_tmp10_ = _tmp9_->pw_name;
#line 167 "../src/PolkitDialog.vala"
						_tmp11_ = g_strdup (_tmp10_);
#line 167 "../src/PolkitDialog.vala"
						pw_name = _tmp11_;
#line 168 "../src/PolkitDialog.vala"
						_tmp13_ = target_user;
#line 168 "../src/PolkitDialog.vala"
						if (_tmp13_ == NULL) {
#line 168 "../src/PolkitDialog.vala"
							_tmp12_ = length < 2;
#line 883 "PolkitDialog.c"
						} else {
#line 168 "../src/PolkitDialog.vala"
							_tmp12_ = FALSE;
#line 887 "PolkitDialog.c"
						}
#line 168 "../src/PolkitDialog.vala"
						if (_tmp12_) {
#line 891 "PolkitDialog.c"
							const gchar* _tmp14_;
							gchar* _tmp15_;
#line 169 "../src/PolkitDialog.vala"
							_tmp14_ = pw_name;
#line 169 "../src/PolkitDialog.vala"
							_tmp15_ = g_strdup (_tmp14_);
#line 169 "../src/PolkitDialog.vala"
							_g_free0 (target_user);
#line 169 "../src/PolkitDialog.vala"
							target_user = _tmp15_;
#line 902 "PolkitDialog.c"
						}
#line 172 "../src/PolkitDialog.vala"
						_tmp16_ = pw_name;
#line 172 "../src/PolkitDialog.vala"
						_tmp17_ = g_strdup (_tmp16_);
#line 172 "../src/PolkitDialog.vala"
						_g_free0 (name);
#line 172 "../src/PolkitDialog.vala"
						name = _tmp17_;
#line 166 "../src/PolkitDialog.vala"
						_g_free0 (pw_name);
#line 914 "PolkitDialog.c"
					}
				} else {
					PolkitIdentity* _tmp18_;
#line 174 "../src/PolkitDialog.vala"
					_tmp18_ = ident;
#line 174 "../src/PolkitDialog.vala"
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp18_, polkit_unix_group_get_type ())) {
#line 922 "PolkitDialog.c"
						struct group* gwd = NULL;
						PolkitIdentity* _tmp19_;
						struct group* _tmp20_;
						struct group* _tmp21_;
#line 175 "../src/PolkitDialog.vala"
						_tmp19_ = ident;
#line 175 "../src/PolkitDialog.vala"
						_tmp20_ = getgrgid ((gid_t) polkit_unix_group_get_gid (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, polkit_unix_group_get_type (), PolkitUnixGroup)));
#line 175 "../src/PolkitDialog.vala"
						gwd = _tmp20_;
#line 176 "../src/PolkitDialog.vala"
						_tmp21_ = gwd;
#line 176 "../src/PolkitDialog.vala"
						if (_tmp21_ != NULL) {
#line 937 "PolkitDialog.c"
							struct group* _tmp22_;
							const gchar* _tmp23_;
							gchar* _tmp24_;
#line 177 "../src/PolkitDialog.vala"
							_tmp22_ = gwd;
#line 177 "../src/PolkitDialog.vala"
							_tmp23_ = _tmp22_->gr_name;
#line 177 "../src/PolkitDialog.vala"
							_tmp24_ = g_strdup_printf (_ ("Group: %s"), _tmp23_);
#line 177 "../src/PolkitDialog.vala"
							_g_free0 (name);
#line 177 "../src/PolkitDialog.vala"
							name = _tmp24_;
#line 951 "PolkitDialog.c"
						}
					}
				}
#line 181 "../src/PolkitDialog.vala"
				_tmp25_ = model;
#line 181 "../src/PolkitDialog.vala"
				gtk_list_store_append (_tmp25_, &_tmp26_);
#line 181 "../src/PolkitDialog.vala"
				iter = _tmp26_;
#line 182 "../src/PolkitDialog.vala"
				_tmp27_ = model;
#line 182 "../src/PolkitDialog.vala"
				_tmp28_ = iter;
#line 182 "../src/PolkitDialog.vala"
				_tmp29_ = name;
#line 182 "../src/PolkitDialog.vala"
				_tmp30_ = ident;
#line 182 "../src/PolkitDialog.vala"
				gtk_list_store_set (_tmp27_, &_tmp28_, 0, "avatar-default-symbolic", 1, _tmp29_, 2, _tmp30_, -1);
#line 184 "../src/PolkitDialog.vala"
				_tmp31_ = name;
#line 184 "../src/PolkitDialog.vala"
				_tmp32_ = g_get_user_name ();
#line 184 "../src/PolkitDialog.vala"
				if (g_strcmp0 (_tmp31_, _tmp32_) == 0) {
#line 185 "../src/PolkitDialog.vala"
					active = length;
#line 979 "PolkitDialog.c"
				}
#line 188 "../src/PolkitDialog.vala"
				_tmp33_ = length;
#line 188 "../src/PolkitDialog.vala"
				length = _tmp33_ + 1;
#line 157 "../src/PolkitDialog.vala"
				_g_free0 (name);
#line 987 "PolkitDialog.c"
			}
		}
	}
#line 191 "../src/PolkitDialog.vala"
	_tmp34_ = self->priv->idents_combo;
#line 191 "../src/PolkitDialog.vala"
	_tmp35_ = model;
#line 191 "../src/PolkitDialog.vala"
	gtk_combo_box_set_model (_tmp34_, (GtkTreeModel*) _tmp35_);
#line 192 "../src/PolkitDialog.vala"
	_tmp36_ = self->priv->idents_combo;
#line 192 "../src/PolkitDialog.vala"
	gtk_combo_box_set_active (_tmp36_, active);
#line 194 "../src/PolkitDialog.vala"
	if (length < 2) {
#line 1003 "PolkitDialog.c"
		const gchar* _tmp37_;
		const gchar* _tmp38_;
#line 195 "../src/PolkitDialog.vala"
		_tmp37_ = target_user;
#line 195 "../src/PolkitDialog.vala"
		_tmp38_ = g_get_user_name ();
#line 195 "../src/PolkitDialog.vala"
		if (g_strcmp0 (_tmp37_, _tmp38_) == 0) {
#line 1012 "PolkitDialog.c"
			GtkComboBox* _tmp39_;
			GtkComboBox* _tmp40_;
#line 196 "../src/PolkitDialog.vala"
			_tmp39_ = self->priv->idents_combo;
#line 196 "../src/PolkitDialog.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp39_, FALSE);
#line 197 "../src/PolkitDialog.vala"
			_tmp40_ = self->priv->idents_combo;
#line 197 "../src/PolkitDialog.vala"
			gtk_widget_set_no_show_all ((GtkWidget*) _tmp40_, TRUE);
#line 1023 "PolkitDialog.c"
		} else {
			GtkComboBox* _tmp41_;
#line 199 "../src/PolkitDialog.vala"
			_tmp41_ = self->priv->idents_combo;
#line 199 "../src/PolkitDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp41_, FALSE);
#line 1030 "PolkitDialog.c"
		}
	}
#line 148 "../src/PolkitDialog.vala"
	_g_free0 (target_user);
#line 148 "../src/PolkitDialog.vala"
	_g_object_unref0 (model);
#line 1037 "PolkitDialog.c"
}

static void
_ag_widgets_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error (PolkitAgentSession* _sender,
                                                                            const gchar* text,
                                                                            gpointer self)
{
#line 210 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_on_pk_show_error ((AgWidgetsPolkitDialog*) self, text);
#line 1047 "PolkitDialog.c"
}

static void
_ag_widgets_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed (PolkitAgentSession* _sender,
                                                                                  gboolean gained_authorization,
                                                                                  gpointer self)
{
#line 211 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_on_pk_session_completed ((AgWidgetsPolkitDialog*) self, gained_authorization);
#line 1057 "PolkitDialog.c"
}

static void
_ag_widgets_polkit_dialog_on_pk_request_polkit_agent_session_request (PolkitAgentSession* _sender,
                                                                      const gchar* request,
                                                                      gboolean echo_on,
                                                                      gpointer self)
{
#line 212 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_on_pk_request ((AgWidgetsPolkitDialog*) self, request, echo_on);
#line 1068 "PolkitDialog.c"
}

static void
_ag_widgets_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info (PolkitAgentSession* _sender,
                                                                          const gchar* text,
                                                                          gpointer self)
{
#line 213 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_on_pk_show_info ((AgWidgetsPolkitDialog*) self, text);
#line 1078 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_select_session (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
	PolkitIdentity* _tmp1_;
	const gchar* _tmp2_;
	PolkitAgentSession* _tmp3_;
	PolkitAgentSession* _tmp4_;
	gulong _tmp5_;
	PolkitAgentSession* _tmp6_;
	gulong _tmp7_;
	PolkitAgentSession* _tmp8_;
	gulong _tmp9_;
	PolkitAgentSession* _tmp10_;
	gulong _tmp11_;
	PolkitAgentSession* _tmp12_;
#line 204 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->pk_session;
#line 205 "../src/PolkitDialog.vala"
	if (_tmp0_ != NULL) {
#line 206 "../src/PolkitDialog.vala"
		ag_widgets_polkit_dialog_deselect_session (self);
#line 1105 "PolkitDialog.c"
	}
#line 209 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->pk_identity;
#line 209 "../src/PolkitDialog.vala"
	_tmp2_ = self->priv->cookie;
#line 209 "../src/PolkitDialog.vala"
	_tmp3_ = polkit_agent_session_new (_tmp1_, _tmp2_);
#line 209 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->pk_session);
#line 209 "../src/PolkitDialog.vala"
	self->priv->pk_session = _tmp3_;
#line 210 "../src/PolkitDialog.vala"
	_tmp4_ = self->priv->pk_session;
#line 210 "../src/PolkitDialog.vala"
	_tmp5_ = g_signal_connect_object (_tmp4_, "show-error", (GCallback) _ag_widgets_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error, self, 0);
#line 210 "../src/PolkitDialog.vala"
	self->priv->error_signal_id = _tmp5_;
#line 211 "../src/PolkitDialog.vala"
	_tmp6_ = self->priv->pk_session;
#line 211 "../src/PolkitDialog.vala"
	_tmp7_ = g_signal_connect_object (_tmp6_, "completed", (GCallback) _ag_widgets_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed, self, 0);
#line 211 "../src/PolkitDialog.vala"
	self->priv->complete_signal_id = _tmp7_;
#line 212 "../src/PolkitDialog.vala"
	_tmp8_ = self->priv->pk_session;
#line 212 "../src/PolkitDialog.vala"
	_tmp9_ = g_signal_connect_object (_tmp8_, "request", (GCallback) _ag_widgets_polkit_dialog_on_pk_request_polkit_agent_session_request, self, 0);
#line 212 "../src/PolkitDialog.vala"
	self->priv->request_signal_id = _tmp9_;
#line 213 "../src/PolkitDialog.vala"
	_tmp10_ = self->priv->pk_session;
#line 213 "../src/PolkitDialog.vala"
	_tmp11_ = g_signal_connect_object (_tmp10_, "show-info", (GCallback) _ag_widgets_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info, self, 0);
#line 213 "../src/PolkitDialog.vala"
	self->priv->info_signal_id = _tmp11_;
#line 214 "../src/PolkitDialog.vala"
	_tmp12_ = self->priv->pk_session;
#line 214 "../src/PolkitDialog.vala"
	polkit_agent_session_initiate (_tmp12_);
#line 1145 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_deselect_session (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
#line 217 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 218 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->pk_session;
#line 218 "../src/PolkitDialog.vala"
	if (_tmp0_ != NULL) {
#line 1158 "PolkitDialog.c"
		PolkitAgentSession* _tmp1_;
		PolkitAgentSession* _tmp2_;
		PolkitAgentSession* _tmp3_;
		PolkitAgentSession* _tmp4_;
#line 219 "../src/PolkitDialog.vala"
		_tmp1_ = self->priv->pk_session;
#line 219 "../src/PolkitDialog.vala"
		g_signal_handler_disconnect (_tmp1_, self->priv->error_signal_id);
#line 220 "../src/PolkitDialog.vala"
		_tmp2_ = self->priv->pk_session;
#line 220 "../src/PolkitDialog.vala"
		g_signal_handler_disconnect (_tmp2_, self->priv->complete_signal_id);
#line 221 "../src/PolkitDialog.vala"
		_tmp3_ = self->priv->pk_session;
#line 221 "../src/PolkitDialog.vala"
		g_signal_handler_disconnect (_tmp3_, self->priv->request_signal_id);
#line 222 "../src/PolkitDialog.vala"
		_tmp4_ = self->priv->pk_session;
#line 222 "../src/PolkitDialog.vala"
		g_signal_handler_disconnect (_tmp4_, self->priv->info_signal_id);
#line 223 "../src/PolkitDialog.vala"
		_g_object_unref0 (self->priv->pk_session);
#line 223 "../src/PolkitDialog.vala"
		self->priv->pk_session = NULL;
#line 1183 "PolkitDialog.c"
	}
}

static void
ag_widgets_polkit_dialog_authenticate (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
	GtkEntry* _tmp1_;
	GtkRevealer* _tmp2_;
	PolkitAgentSession* _tmp3_;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
#line 227 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 228 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->pk_session;
#line 228 "../src/PolkitDialog.vala"
	if (_tmp0_ == NULL) {
#line 229 "../src/PolkitDialog.vala"
		ag_widgets_polkit_dialog_select_session (self);
#line 1204 "PolkitDialog.c"
	}
#line 232 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->password_entry;
#line 232 "../src/PolkitDialog.vala"
	g_object_set (_tmp1_, "secondary-icon-name", "", NULL);
#line 233 "../src/PolkitDialog.vala"
	_tmp2_ = self->priv->feedback_revealer;
#line 233 "../src/PolkitDialog.vala"
	gtk_revealer_set_reveal_child (_tmp2_, FALSE);
#line 235 "../src/PolkitDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self, FALSE);
#line 236 "../src/PolkitDialog.vala"
	_tmp3_ = self->priv->pk_session;
#line 236 "../src/PolkitDialog.vala"
	_tmp4_ = self->priv->password_entry;
#line 236 "../src/PolkitDialog.vala"
	_tmp5_ = gtk_entry_get_text (_tmp4_);
#line 236 "../src/PolkitDialog.vala"
	polkit_agent_session_response (_tmp3_, _tmp5_);
#line 1224 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_cancel (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
#line 239 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 240 "../src/PolkitDialog.vala"
	self->priv->canceling = TRUE;
#line 241 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->pk_session;
#line 241 "../src/PolkitDialog.vala"
	if (_tmp0_ != NULL) {
#line 1239 "PolkitDialog.c"
		PolkitAgentSession* _tmp1_;
#line 242 "../src/PolkitDialog.vala"
		_tmp1_ = self->priv->pk_session;
#line 242 "../src/PolkitDialog.vala"
		polkit_agent_session_cancel (_tmp1_);
#line 1245 "PolkitDialog.c"
	}
#line 245 "../src/PolkitDialog.vala"
	g_debug ("PolkitDialog.vala:245: Authentication cancelled");
#line 246 "../src/PolkitDialog.vala"
	self->was_canceled = TRUE;
#line 248 "../src/PolkitDialog.vala"
	self->priv->canceling = FALSE;
#line 249 "../src/PolkitDialog.vala"
	g_signal_emit (self, ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL], 0);
#line 1255 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_on_ident_changed (AgWidgetsPolkitDialog* self)
{
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	GtkTreeModel* model = NULL;
	GtkComboBox* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeModel* _tmp7_;
	GtkTreeIter _tmp8_;
	PolkitIdentity* _tmp9_ = NULL;
#line 252 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 255 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->idents_combo;
#line 255 "../src/PolkitDialog.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 255 "../src/PolkitDialog.vala"
	iter = _tmp1_;
#line 255 "../src/PolkitDialog.vala"
	if (!_tmp2_) {
#line 256 "../src/PolkitDialog.vala"
		ag_widgets_polkit_dialog_deselect_session (self);
#line 257 "../src/PolkitDialog.vala"
		return;
#line 1287 "PolkitDialog.c"
	}
#line 260 "../src/PolkitDialog.vala"
	_tmp3_ = self->priv->idents_combo;
#line 260 "../src/PolkitDialog.vala"
	_tmp4_ = gtk_combo_box_get_model (_tmp3_);
#line 260 "../src/PolkitDialog.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 260 "../src/PolkitDialog.vala"
	model = _tmp5_;
#line 261 "../src/PolkitDialog.vala"
	_tmp6_ = model;
#line 261 "../src/PolkitDialog.vala"
	if (_tmp6_ == NULL) {
#line 262 "../src/PolkitDialog.vala"
		_g_object_unref0 (model);
#line 262 "../src/PolkitDialog.vala"
		return;
#line 1305 "PolkitDialog.c"
	}
#line 265 "../src/PolkitDialog.vala"
	_tmp7_ = model;
#line 265 "../src/PolkitDialog.vala"
	_tmp8_ = iter;
#line 265 "../src/PolkitDialog.vala"
	gtk_tree_model_get (_tmp7_, &_tmp8_, 2, &_tmp9_, -1, -1);
#line 265 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->pk_identity);
#line 265 "../src/PolkitDialog.vala"
	self->priv->pk_identity = _tmp9_;
#line 266 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_select_session (self);
#line 252 "../src/PolkitDialog.vala"
	_g_object_unref0 (model);
#line 1321 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_on_pk_session_completed (AgWidgetsPolkitDialog* self,
                                                  gboolean authorized)
{
	gboolean _tmp0_ = FALSE;
#line 269 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 270 "../src/PolkitDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self, TRUE);
#line 271 "../src/PolkitDialog.vala"
	if (!authorized) {
#line 271 "../src/PolkitDialog.vala"
		_tmp0_ = TRUE;
#line 1337 "PolkitDialog.c"
	} else {
		GCancellable* _tmp1_;
#line 271 "../src/PolkitDialog.vala"
		_tmp1_ = self->priv->cancellable;
#line 271 "../src/PolkitDialog.vala"
		_tmp0_ = g_cancellable_is_cancelled (_tmp1_);
#line 1344 "PolkitDialog.c"
	}
#line 271 "../src/PolkitDialog.vala"
	if (_tmp0_) {
#line 1348 "PolkitDialog.c"
		GtkEntry* _tmp2_;
		GtkEntry* _tmp3_;
#line 272 "../src/PolkitDialog.vala"
		if (!self->priv->canceling) {
#line 273 "../src/PolkitDialog.vala"
			ag_widgets_polkit_dialog_on_pk_show_error (self, _ ("Authentication failed. Please try again."));
#line 1355 "PolkitDialog.c"
		}
#line 276 "../src/PolkitDialog.vala"
		ag_widgets_polkit_dialog_deselect_session (self);
#line 277 "../src/PolkitDialog.vala"
		_tmp2_ = self->priv->password_entry;
#line 277 "../src/PolkitDialog.vala"
		gtk_entry_set_text (_tmp2_, "");
#line 278 "../src/PolkitDialog.vala"
		_tmp3_ = self->priv->password_entry;
#line 278 "../src/PolkitDialog.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp3_);
#line 279 "../src/PolkitDialog.vala"
		ag_widgets_polkit_dialog_select_session (self);
#line 280 "../src/PolkitDialog.vala"
		return;
#line 1371 "PolkitDialog.c"
	} else {
#line 282 "../src/PolkitDialog.vala"
		g_signal_emit (self, ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL], 0);
#line 1375 "PolkitDialog.c"
	}
}

static void
ag_widgets_polkit_dialog_on_pk_request (AgWidgetsPolkitDialog* self,
                                        const gchar* request,
                                        gboolean echo_on)
{
	GtkEntry* _tmp0_;
#line 286 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 286 "../src/PolkitDialog.vala"
	g_return_if_fail (request != NULL);
#line 287 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->password_entry;
#line 287 "../src/PolkitDialog.vala"
	gtk_entry_set_visibility (_tmp0_, echo_on);
#line 288 "../src/PolkitDialog.vala"
	if (!g_str_has_prefix (request, "Password:")) {
#line 1395 "PolkitDialog.c"
		GtkLabel* _tmp1_;
#line 289 "../src/PolkitDialog.vala"
		_tmp1_ = self->priv->password_label;
#line 289 "../src/PolkitDialog.vala"
		gtk_label_set_label (_tmp1_, request);
#line 1401 "PolkitDialog.c"
	}
}

static void
ag_widgets_polkit_dialog_on_pk_show_error (AgWidgetsPolkitDialog* self,
                                           const gchar* text)
{
	GtkEntry* _tmp0_;
	GtkLabel* _tmp1_;
	GtkRevealer* _tmp2_;
#line 293 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 293 "../src/PolkitDialog.vala"
	g_return_if_fail (text != NULL);
#line 294 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->password_entry;
#line 294 "../src/PolkitDialog.vala"
	g_object_set (_tmp0_, "secondary-icon-name", "dialog-error-symbolic", NULL);
#line 295 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->password_feedback;
#line 295 "../src/PolkitDialog.vala"
	gtk_label_set_label (_tmp1_, text);
#line 296 "../src/PolkitDialog.vala"
	_tmp2_ = self->priv->feedback_revealer;
#line 296 "../src/PolkitDialog.vala"
	gtk_revealer_set_reveal_child (_tmp2_, TRUE);
#line 297 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_shake (self);
#line 1430 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_shake (AgWidgetsPolkitDialog* self)
{
	gint x = 0;
	gint y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 301 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 303 "../src/PolkitDialog.vala"
	gtk_window_get_position ((GtkWindow*) self, &_tmp0_, &_tmp1_);
#line 303 "../src/PolkitDialog.vala"
	x = _tmp0_;
#line 303 "../src/PolkitDialog.vala"
	y = _tmp1_;
#line 1448 "PolkitDialog.c"
	{
		gint n = 0;
#line 305 "../src/PolkitDialog.vala"
		n = 0;
#line 1453 "PolkitDialog.c"
		{
			gboolean _tmp2_ = FALSE;
#line 305 "../src/PolkitDialog.vala"
			_tmp2_ = TRUE;
#line 305 "../src/PolkitDialog.vala"
			while (TRUE) {
#line 1460 "PolkitDialog.c"
				gint diff = 0;
#line 305 "../src/PolkitDialog.vala"
				if (!_tmp2_) {
#line 1464 "PolkitDialog.c"
					gint _tmp3_;
#line 305 "../src/PolkitDialog.vala"
					_tmp3_ = n;
#line 305 "../src/PolkitDialog.vala"
					n = _tmp3_ + 1;
#line 1470 "PolkitDialog.c"
				}
#line 305 "../src/PolkitDialog.vala"
				_tmp2_ = FALSE;
#line 305 "../src/PolkitDialog.vala"
				if (!(n < 10)) {
#line 305 "../src/PolkitDialog.vala"
					break;
#line 1478 "PolkitDialog.c"
				}
#line 306 "../src/PolkitDialog.vala"
				diff = 15;
#line 307 "../src/PolkitDialog.vala"
				if ((n % 2) == 0) {
#line 308 "../src/PolkitDialog.vala"
					diff = -15;
#line 1486 "PolkitDialog.c"
				}
#line 311 "../src/PolkitDialog.vala"
				gtk_window_move ((GtkWindow*) self, x + diff, y);
#line 313 "../src/PolkitDialog.vala"
				while (TRUE) {
#line 313 "../src/PolkitDialog.vala"
					if (!gtk_events_pending ()) {
#line 313 "../src/PolkitDialog.vala"
						break;
#line 1496 "PolkitDialog.c"
					}
#line 314 "../src/PolkitDialog.vala"
					gtk_main_iteration ();
#line 1500 "PolkitDialog.c"
				}
#line 317 "../src/PolkitDialog.vala"
				g_usleep ((gulong) 10000);
#line 1504 "PolkitDialog.c"
			}
		}
	}
#line 320 "../src/PolkitDialog.vala"
	gtk_window_move ((GtkWindow*) self, x, y);
#line 1510 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_on_pk_show_info (AgWidgetsPolkitDialog* self,
                                          const gchar* text)
{
#line 323 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 323 "../src/PolkitDialog.vala"
	g_return_if_fail (text != NULL);
#line 324 "../src/PolkitDialog.vala"
	g_info ("PolkitDialog.vala:324: %s", text);
#line 1523 "PolkitDialog.c"
}

static gboolean
ag_widgets_polkit_dialog_on_key_release (AgWidgetsPolkitDialog* self,
                                         GdkEventKey* key)
{
	gboolean result;
#line 327 "../src/PolkitDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 327 "../src/PolkitDialog.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 328 "../src/PolkitDialog.vala"
	switch (key->keyval) {
#line 328 "../src/PolkitDialog.vala"
		case GDK_KEY_KP_Enter:
#line 328 "../src/PolkitDialog.vala"
		case GDK_KEY_Return:
#line 1541 "PolkitDialog.c"
		{
#line 331 "../src/PolkitDialog.vala"
			ag_widgets_polkit_dialog_authenticate (self);
#line 332 "../src/PolkitDialog.vala"
			result = GDK_EVENT_STOP;
#line 332 "../src/PolkitDialog.vala"
			return result;
#line 1549 "PolkitDialog.c"
		}
		default:
#line 328 "../src/PolkitDialog.vala"
		break;
#line 1554 "PolkitDialog.c"
	}
#line 335 "../src/PolkitDialog.vala"
	result = GDK_EVENT_PROPAGATE;
#line 335 "../src/PolkitDialog.vala"
	return result;
#line 1560 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_class_init (AgWidgetsPolkitDialogClass * klass,
                                     gpointer klass_data)
{
#line 27 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/PolkitDialog.vala"
	g_type_class_adjust_private_offset (klass, &AgWidgetsPolkitDialog_private_offset);
#line 27 "../src/PolkitDialog.vala"
	((GtkWidgetClass *) klass)->show = (void (*) (GtkWidget*)) ag_widgets_polkit_dialog_real_show;
#line 27 "../src/PolkitDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = ag_widgets_polkit_dialog_finalize;
#line 27 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL] = g_signal_new ("done", AG_WIDGETS_TYPE_POLKIT_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1577 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_instance_init (AgWidgetsPolkitDialog * self,
                                        gpointer klass)
{
#line 27 "../src/PolkitDialog.vala"
	self->priv = ag_widgets_polkit_dialog_get_instance_private (self);
#line 29 "../src/PolkitDialog.vala"
	self->was_canceled = FALSE;
#line 31 "../src/PolkitDialog.vala"
	self->priv->pk_session = NULL;
#line 32 "../src/PolkitDialog.vala"
	self->priv->pk_identity = NULL;
#line 42 "../src/PolkitDialog.vala"
	self->priv->canceling = FALSE;
#line 1594 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_finalize (GObject * obj)
{
	AgWidgetsPolkitDialog * self;
#line 27 "../src/PolkitDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialog);
#line 31 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->pk_session);
#line 32 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->pk_identity);
#line 41 "../src/PolkitDialog.vala"
	_g_free0 (self->priv->cookie);
#line 44 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->feedback_revealer);
#line 45 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_label);
#line 46 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_feedback);
#line 47 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_entry);
#line 48 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->idents_combo);
#line 27 "../src/PolkitDialog.vala"
	G_OBJECT_CLASS (ag_widgets_polkit_dialog_parent_class)->finalize (obj);
#line 1621 "PolkitDialog.c"
}

static GType
ag_widgets_polkit_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AgWidgetsPolkitDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ag_widgets_polkit_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AgWidgetsPolkitDialog), 0, (GInstanceInitFunc) ag_widgets_polkit_dialog_instance_init, NULL };
	GType ag_widgets_polkit_dialog_type_id;
	ag_widgets_polkit_dialog_type_id = g_type_register_static (GRANITE_TYPE_MESSAGE_DIALOG, "AgWidgetsPolkitDialog", &g_define_type_info, 0);
	AgWidgetsPolkitDialog_private_offset = g_type_add_instance_private (ag_widgets_polkit_dialog_type_id, sizeof (AgWidgetsPolkitDialogPrivate));
	return ag_widgets_polkit_dialog_type_id;
}

GType
ag_widgets_polkit_dialog_get_type (void)
{
	static volatile gsize ag_widgets_polkit_dialog_type_id__once = 0;
	if (g_once_init_enter (&ag_widgets_polkit_dialog_type_id__once)) {
		GType ag_widgets_polkit_dialog_type_id;
		ag_widgets_polkit_dialog_type_id = ag_widgets_polkit_dialog_get_type_once ();
		g_once_init_leave (&ag_widgets_polkit_dialog_type_id__once, ag_widgets_polkit_dialog_type_id);
	}
	return ag_widgets_polkit_dialog_type_id__once;
}

